#ifndef VIETER_JOB_QUEUE_INTERNAL
#define VIETER_JOB_QUEUE_INTERNAL

#include "vieter_cat_heap.h"
#include "vieter_heap.h"
#include "vieter_job_queue.h"
#include "vieter_tree.h"
#include <pthread.h>

struct vieter_job_queue {
  vieter_tree *tree;
  union {
    vieter_heap *heap;
    vieter_cat_heap *cat_heap;
  } heaps[VIETER_JOB_STATES];
  pthread_rwlock_t lock;
};

#endif
